DCMTK: FGUnknown Class Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | Private Member Functions | Private Attributes | List of all members
FGUnknown Class Reference

Class representing an "unknown" functional group, e.g. a private one specified by a vendor or one that is not explicitly known yet to the dcmfg library. More...

Inheritance diagram for FGUnknown:

## Public Member Functions
| FGUnknown (const DcmTagKey &seqStartTag, const DcmFGTypes::E_FGSharedType sharedType=DcmFGTypes::EFGS_UNKNOWN)
| Creates unknown (to the dcmfg class library) functional group.
| FGUnknown (const FGUnknown &rhs)
| Copy constructor, performs a deep copy of the given object.
FGUnknown & | operator= (const FGUnknown &rhs)
| Assignment operator, performs a deep copy for assigning given object.
virtual DcmFGTypes::E_FGType | getType () const
| Returns type of this functional group (always "EFG_UNKNOWN")
virtual DcmFGTypes::E_FGSharedType | getSharedType () const
| Returns whether this group is potentially per-frame, shared or can be both.
virtual FGBase * | clone () const
| Returns a deep copy of this object.
virtual OFCondition | check () const
| Check whether this functional group contains valid data.
virtual void | clearData ()
| Clear data within this group.
virtual OFCondition | read (DcmItem &item)
| Read this group into memory.
virtual OFCondition | write (DcmItem &item)
| Write this group to given item.
virtual int | compare (const FGBase &rhs) const
| Comparison operator that compares the normalized value of this object with a given object of the same type, i.e. the elements within both functional groups (this and rhs parameter) are compared by value!
virtual | ~FGUnknown ()
| Virtual destructor, frees memory.
Public Member Functions inherited from FGBase
| FGBase (const DcmFGTypes::E_FGType fgType)
| Constructor, creates new functional group of given type.
virtual | ~FGBase ()
| Virtual destructor.

## Private Member Functions
| FGUnknown ()
| Private default constructor, shall not be used.

## Private Attributes
DcmTagKey | m_seqStartTag
| The tag that uniquely identifies this functional group.
DcmSequenceOfItems * | m_fgSequence
| The data hold by this item, i.e. the sequence making up the functional group.
DcmFGTypes::E_FGSharedType | m_sharedType
| Denotes whether this group is potentially per-frame, shared or can be both.

## Additional Inherited Members
Protected Member Functions inherited from FGBase
virtual OFCondition | getItemFromFGSequence (DcmItem &source, const DcmTagKey &seqKey, const unsigned long itemNum, DcmItem *&result)
| Get the item containing the payload of a functional group sequence, identified by the functional group's sequence key provided and the desired item number.
virtual OFCondition | getNumItemsFromFGSequence (DcmItem &source, const DcmTagKey &seqKey, unsigned long &result)
| Get number of items in a functional group sequence, identified by the functional group's sequence key.
virtual OFCondition | createNewFGSequence (DcmItem &destination, const DcmTagKey &seqKey, const unsigned long numItems, DcmItem *&firstItem)
| Create functional group sequence specified by given sequence tag key.

## Detailed Description

Class representing an "unknown" functional group, e.g. a private one specified by a vendor or one that is not explicitly known yet to the dcmfg library.

The main purpose is to have a container for such functional groups that allows to read them into memory, access them using a low level API, and to be able to write store them back.

## Constructor & Destructor Documentation

## ◆ FGUnknown() [1/2]

FGUnknown::FGUnknown | ( | const DcmTagKey & | seqStartTag,
|  | const DcmFGTypes::E_FGSharedType | sharedType = DcmFGTypes::EFGS_UNKNOWN )

Creates unknown (to the dcmfg class library) functional group.

Parameters

  seqStartTag | The tag that uniquely identifies this functional group
  sharedType | Defines whether this group is potentially per-frame, shared or can be both. Default is "unknown".

References DcmFGTypes::EFGS_UNKNOWN.

Referenced by FGUnknown(), and operator=().

## ◆ FGUnknown() [2/2]

FGUnknown::FGUnknown | ( | const FGUnknown & | rhs | ) |

Copy constructor, performs a deep copy of the given object.

Parameters

  rhs | The functional group to initialize from

References FGUnknown().

## Member Function Documentation

## ◆ check()

virtual OFCondition FGUnknown::check | ( |  | ) | const
| virtual

Check whether this functional group contains valid data.

Returns
  EC_Normal if functional group is valid. For now, always returns EC_Normal

Implements FGBase.

## ◆ clone()

virtual FGBase * FGUnknown::clone | ( |  | ) | const
| virtual

Returns a deep copy of this object.

Returns
  Deep copy of this object

Implements FGBase.

References FGBase::FGBase().

## ◆ compare()

virtual int FGUnknown::compare | ( | const FGBase & | rhs | ) | const
| virtual

Comparison operator that compares the normalized value of this object with a given object of the same type, i.e. the elements within both functional groups (this and rhs parameter) are compared by value!

Both objects (this and rhs) need to have the same type (i.e. both FGUnknown) to be comparable. This function is used in order to decide whether a functional group already exists, or is new. This is used in particular to find out whether a given functional group can be shared (i.e. the same information already exists as shared functional group) or is different from the same shared group. In that case the shared functional group must be distributed into per-frame functional groups, instead. The exact implementation for implementing the comparison is not relevant. However, it must be a comparison by value.

Parameters

  rhs | the right hand side of the comparison

Returns
  0 if the object values are equal. -1 if either the value of the first component that does not match is lower in the this object, or all compared components match but this component is shorter. Also returned if this type and rhs type (DcmFGTypes::E_FGType) do not match. 1 if either the value of the first component that does not match is greater in this object, or all compared components match but this component is longer.

Implements FGBase.

References FGBase::FGBase().

## ◆ getSharedType()

virtual DcmFGTypes::E_FGSharedType FGUnknown::getSharedType | ( |  | ) | const
| inlinevirtual

Returns whether this group is potentially per-frame, shared or can be both.

Returns
  The functional group's "shared type"

Implements FGBase.

References m_sharedType.

## ◆ getType()

virtual DcmFGTypes::E_FGType FGUnknown::getType | ( |  | ) | const
| inlinevirtual

Returns type of this functional group (always "EFG_UNKNOWN")

Returns
  Always returns DcmFGTypes::EFG_UNKNOWN

Reimplemented from FGBase.

References DcmFGTypes::EFG_UNKNOWN.

## ◆ operator=()

FGUnknown & FGUnknown::operator= | ( | const FGUnknown & | rhs | ) |

Assignment operator, performs a deep copy for assigning given object.

Parameters

  rhs | The functional group to assign from

Returns
  Reference to this object

References FGUnknown().

## ◆ read()

virtual OFCondition FGUnknown::read | ( | DcmItem & | item | ) |
| virtual

Read this group into memory.

Parameters

  item | The item to read from

Returns
  EC_Normal if reading was successful, error code otherwise

Implements FGBase.

## ◆ write()

virtual OFCondition FGUnknown::write | ( | DcmItem & | item | ) |
| virtual

Write this group to given item.

Parameters

  item | The item to write to

Returns
  EC_Normal if writing was successful, error code otherwise

Implements FGBase.

The documentation for this class was generated from the following file:

- dcmfg/include/dcmtk/dcmfg/fgbase.h

Generated on Wed Apr 30 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2